/*
Blink using Timer interrupts
from Linux Format 154
based on code and ideas from:
arduino playground - www.arduino.cc
Michael Smith <michael@hurts.ca>
Atmel datasheets - http://www.atmel.com/
*/

/* LISTING 3
* In this version we use the comparitor A to get a more accurate time interval.   
* Setting it to 65249 means we get an accurate 1 second gap 
* 
*/


void setup() {

DDRB |= _BV(PB5); // set LED pin as output

cli(); // stop interrupts while we meddle with the clocks
TCNT1=0x0000; // reset counter to 0 at start
TCCR1A= B00000000; // turn off PWM
TCCR1B= B00001100; // set CTC on and prescalar to /256
TIMSK1 |= _BV(OCIE1A) ; // enable timer compare A interrupt
OCR1A = 62499; //set the comparator A to trigger at 1 second
sei(); //start interrupts again
// start serial access - this is to get around a bug on some
// systems which don't initialise the data segment properly
Serial.begin(9600);
};

void loop () {
///your useful code here

delay(1234);
};


ISR(TIMER1_COMPA_vect) {
//toggle the value
PORTB ^= _BV(PB5);
// this works by XORing the bit with 1, which turns 1 to 0 and 0 to 1
}


